<?php
namespace Claromentis\Blog\Comments;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"] ?: array()) + array("_8dabb06e" . "fc95df4cf" . "f7c4afe91" . "857b53" => base64_decode("bmFtZQ=" . "="), "_c927258f53222" . "88a992c77be40a" . "e0b53" => base64_decode("dX" . "Js"), "_c7b86566f5835e" . "34c8ef0cf3b36b6" . "046" => base64_decode("L2Jsb2" . "cv"), "_f784524629d9404cd62ba9e" . "1475d3bc3" => base64_decode("b2JqZWN0X2" . "5hbWU="), "_e06da3f" . "fba2e84b" . "8e6f94bd" . "2d6ca3c5" . "2" => base64_decode("Y3JlYXRlX2l" . "udGVybmFsX2" . "xpbms="), "_2457e28fb4d91b5f7528008953d" . "956b5" => base64_decode("YmxvZy5jb21t" . "b24uYmxvZw=="), "_a591754a8ddcdbda9c80f" . "1db4d911e14" => base64_decode("aXNf" . "bnVs" . "bA=="), "_48a68e7" . "cee9866c" . "9a733099" . "222c3ab9" . "c" => base64_decode("L2Js" . "b2c="), "_0c5123a" . "a744f69b" . "bc0e8b3e" . "a2f6e847" . "d" => base64_decode("bG1" . "zZw" . "=="), "_87daa84e346f6420a" . "3f3426e05d16a7b" => base64_decode("Lw" . "=="));
use Claromentis\Comments\CommentableInterface;
use Claromentis\Comments\CommentLocationInterface;
use Claromentis\Comments\CommentsRepository;
use Claromentis\Comments\Model\Comment;
use Claromentis\Comments\Notification\Notification;
use Claromentis\Comments\SupportedOptions;
use Claromentis\Comments\Rights;
use Claromentis\Core\Security\SecurityContext;
use BlogPost;
use Claromentis\Core\Services;




class CommentableBlog implements CommentableInterface, CommentLocationInterface
{
    private $blog_id;
    
    
    
    
    private $blog_post;
    
    
    
    
    
    
    public static function CreateFromObject(BlogPost $_d46d6e01a4991a0a517398cada804774)
    {
        $_68ffaaa31e3ba49ed9d6159fbee9f043 = new static();
        $_68ffaaa31e3ba49ed9d6159fbee9f043->blog_post = $_d46d6e01a4991a0a517398cada804774;
        $_68ffaaa31e3ba49ed9d6159fbee9f043->blog_id = $_d46d6e01a4991a0a517398cada804774->GetId();
        return $_68ffaaa31e3ba49ed9d6159fbee9f043;
    }
    public static function DeleteFromObject(BlogPost $_d46d6e01a4991a0a517398cada804774)
    {
        $_5e1e8bdeb7dc6725dab2802927e4f193 = self::CreateFromObject($_d46d6e01a4991a0a517398cada804774);
        
        
        $_d494fa2121915ac5ef3cbbab4c40bef2 = Services::I()->{CommentsRepository::class};
        $_d494fa2121915ac5ef3cbbab4c40bef2->DeleteAllForObject($_5e1e8bdeb7dc6725dab2802927e4f193);
    }
    
    
    
    
    
    
    
    
    
    public function Load($_0ea4e32b57963ac0cb3057e03e9aef64, $_4a033bdf0ce701c6255d5238633ab2d0 = array())
    {
        $this->blog_id = $_0ea4e32b57963ac0cb3057e03e9aef64;
        $this->blog_post = null;
    }
    
    
    
    
    
    
    public function GetAggregationObject()
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_a591754a8ddcdbda9c80f1db4" . "d911e14"]($this->blog_post)) {
            $this->blog_post = new BlogPost($this->blog_id);
        }
        return $this->blog_post;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function UserHasPermission(SecurityContext $context, $_a18f3f2e515f9b634cee4e5fbdcdb572, Comment $_e8d840684607f6c2bbef523090642168 = null)
    {
        
        
        $_d46d6e01a4991a0a517398cada804774 = $this->GetAggregationObject();
        if (!$_d46d6e01a4991a0a517398cada804774->UserHasPermission(PERM_VIEW)) {
            return false;
        }
        if ($_a18f3f2e515f9b634cee4e5fbdcdb572 != Rights::PERM_VIEW && !$_d46d6e01a4991a0a517398cada804774->IsCommentingEnabled()) {
            return false;
        }
        if (($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_EDIT) == Rights::PERM_EDIT || ($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_DELETE) == Rights::PERM_DELETE) {
            if (!$_d46d6e01a4991a0a517398cada804774->UserHasPermission(PERM_APPROVE)) {
                if ($_e8d840684607f6c2bbef523090642168 && (int) $_e8d840684607f6c2bbef523090642168->user_id !== $context->GetUserId()) {
                    return false;
                }
            }
        }
        if ($_e8d840684607f6c2bbef523090642168 && ($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_DELETE) == Rights::PERM_DELETE && $_e8d840684607f6c2bbef523090642168->HasReplies()) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetOptions()
    {
        return [SupportedOptions::REPLIES => true, SupportedOptions::LIKES => true, SupportedOptions::ATTACHMENTS => true];
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function Notify(Comment $_e8d840684607f6c2bbef523090642168, Notification $_0dfb4a13f8c551dff0f061eebc847961)
    {
        $_0dfb4a13f8c551dff0f061eebc847961->type = \IMessage::TYPE_BLOG;
        $_d46d6e01a4991a0a517398cada804774 = $this->GetAggregationObject();
        $_0dfb4a13f8c551dff0f061eebc847961->AddTemplateValues([$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_f784524629d9404" . "cd62ba9e1475d3bc" . "3"] => $_d46d6e01a4991a0a517398cada804774->GetTitle()]);
        $_0dfb4a13f8c551dff0f061eebc847961->Send();
    }
    public function GetBreadcrumbs(int $_2d876b122533fac9677b16ea6c640aa6)
    {
        $_d46d6e01a4991a0a517398cada804774 = $_d46d6e01a4991a0a517398cada804774 = new BlogPost($_2d876b122533fac9677b16ea6c640aa6);
        return [[$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_8dabb06efc9" . "5df4cff7c4af" . "e91857b53"] => $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_0c5123aa744f69bbc0e8b3ea2f6e8" . "47d"]($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_2457e28fb4d91" . "b5f7528008953d" . "956b5"]), $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_c927258f5322288a992c77be40ae0" . "b53"] => $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_e06da3ffba2e84b8e6f94bd2d" . "6ca3c52"]($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_48a68e7cee986" . "6c9a733099222c" . "3ab9c"])], [$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_8dabb06efc95df4cff7c4afe91" . "857b53"] => $_d46d6e01a4991a0a517398cada804774->GetTitle(), $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_c927258f53222" . "88a992c77be40a" . "e0b53"] => $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_e06da3ffba2" . "e84b8e6f94bd" . "2d6ca3c52"]($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_c7b86566f5835e34c8ef0cf3b36b" . "6046"] . $_d46d6e01a4991a0a517398cada804774->channel_id . $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_87daa84e346f6420a3" . "f3426e05d16a7b"] . $_d46d6e01a4991a0a517398cada804774->id)]];
    }
}